var trendingDialog, dialogOptions, dialogSaveButton, dialogCancelButton, seriesOptions, chart, data, rows, checkBoxes;
var graphCreated = false;
var trendingLimit = 8;
$(document).ready(function(){
//    $(".trending-error").hide();
//    $(".select-data-button").bind(mouseDownEvent, function(b) {
//        registerMouseDown();
//        showTrendingDialog(b);
//        return false
//    });
    Highcharts.theme = graphTheme;
    Highcharts.setOptions(Highcharts.theme);
    Highcharts.setOptions({
        global: {
            useUTC: false
        }
    });
    createChart()
});

function createChart() {
    if (graphCreated) {
        return true
    }
    graphCreated = true;
    seriesOptions = [];
    chart = new Highcharts.Chart(graphOptions)
}

function graphEventLoad() {
    graphEventLoadHelper();
    if (!graphRepeating) {
        debug("Data is not repeating lets make it repeat");
        setInterval(function() {
            graphEventLoad()
        }, refreshRate);
        graphRepeating = true
    } else {
        debug("Data is already repeating")
    }
}

function graphEventLoadHelper() {
    getData()
}

function showTrendingDialog(a) {
    trendingDialog = $(".ui-page-active .trending_selection");
    dialogOptions = trendingDialog.find(".ui-checkbox input");
    dialogSaveButton = trendingDialog.find(".save-trending-data-points");
    dialogCancelButton = trendingDialog.find(".cancel-trending-data-points");
    checkBoxes = trendingDialog.find('input[type="checkbox"]');
    showDialog(trendingDialog, a);
    checkBoxes.change(function() {
        if ($(this).attr("checked") == "checked") {
            numSelected++
        } else {
            numSelected--
        }
        debug("Num Selected:" + numSelected);
        if (numSelected > trendingLimit) {
            numSelected--;
            $(".trending-error").show();
            setTimeout(function() {
                $(".trending-error").hide()
            }, 2000);
            $(this).attr("checked", false);
            $(this).checkboxradio("refresh")
        }
    });
    dialogSaveButton.unbind();
    dialogSaveButton.bind(mouseDownEvent, function() {
        selectedTrendingPoints = new Array();
        var b = 1;
        $.each(dialogOptions, function() {
            var c = $(this);
            if (c.attr("checked")) {
                selectedTrendingPoints.push("a." + c.val());
                writeValue("ModeData." + sharedMemoryPrefix + b, c.val());
                b++
            }
        });
        for (z = b; z <= 8; z++) {
            writeValue("ModeData." + sharedMemoryPrefix + z, "128")
        }
        if (sharedMemoryPrefix == "real_time_trending_channel_") {
            writeValue("ModeData.flag_for_hmi_process_to_initialize_various_trending_data", "1")
        }
        hideDialog(trendingDialog);
        showLoading();
        setTimeout(function() {
            window.location.reload(true)
        }, 2000)
    })
}

function TrendingPointsSaved(c) {
    if (!c) {
        alert("There was a problem saving.")
    }
    var b = $(".ui-page-active .trending_selection .trending-button-holder");
    var a = b.height();
    b.empty();
    b.css("text-align", "center");
    b.append($("<h1>Please wait while trending points are cleared. <br />This page will automatically refresh.</h1>").css("color", "white"));
    b.append($("<img />").attr("src", "/images/ajax-loader-blue.gif"));
    b.height(a);
    var d = {
        callBack: "ClearData",
        repeat: false,
        method: "clearRealTimeTrending"
    };
    requestData(d)
}

function ClearData(a) {
    window.location.reload(true)
};