package main

import (
	"database/sql"
	migration "bitbucket.org/prmunty/util/dbmigration/db"
	_ "github.com/mattn/go-sqlite3"
)

func main() {
	const version float64 = 2.0

	migration.Migrate(version, func(tx *sql.Tx) (err error) {
		return migration.DoUntilErr(tx,
			DoNothing,
		)
	})

}


func DoNothing(tx *sql.Tx) error {
	return nil
}
